'Program to connect PS/2 Keyboard to 8-Bit Parallel Bus on LALU16
'M. Mruzek 7/26/2022. See Keyboard PCB designed same date.
'Use this program in PICAXE-20X2 in special PCB designed for purpose
'Version 3 Registers KBD Byte when BR, S0 and S1 all go HIGH
'Version 4 Blocks KBD read while S-R FF is being set using C.4
'Version 5 Added more keys to the translation table 9/23/2022
PAUSE 500 'Pause for 1/2 second during startup transients
'Setup and initialize pins for input and output...
OUTPUT B.0 'LSB of Keyboard Output
LOW B.0
OUTPUT B.1 'Keyboard data
LOW B.1
OUTPUT B.2 'Keyboard data
LOW B.2
OUTPUT B.3 'Keyboard data
LOW B.3
OUTPUT B.4 'Keyboard data
LOW B.4
OUTPUT B.5 'Keyboard data
LOW B.5
OUTPUT B.6 'MSB of Keyboard Output
LOW B.6
OUTPUT B.7 'Not actually used.(Bit 7 is Q of RS Flip Flop)
LOW B.7
OUTPUT C.0 'SET signal to S-R Flip Flop
LOW C.0
INPUT  C.3 'Q (Output) from the S-R Flip Flop
'Version 4: Use C.4 to block KBD reads during FF SET
OUTPUT C.4 'H=Keyboard Read OK, L=Keyboard Read NOT ALLOWED
LOW C.4
'Verify S-R Flip Flop output Q is low. If not, send a RESET
'IF PINC.3 = 0 THEN GOTO JUMP1
'HIGH C.4 'Otherwise send a short pulse to reset...
'LOW C.4
'NOTE: Commenting above OUT makes junk possible at start-up
'Turn off the flashing LED's for keystroke detected
'Flashing LEDs make key acquisition much slower!
KEYLED %10000000
'This is start of repetitive loop for keypress acquisition
JUMP1:
B2=$3F 'Use ASCII for "?" as default character
'Wait for a keypress...
START:
KBIN [20,START], B1 'Wait for Key to be Hit (No exit!)
'PICAXE uses non-standard codes. Must translate to standard ASCII codes
'Note: A jump after any substitution can be done to increase speed
'Note: Explore using a translation table to make this faster!
'Note: Keypad must be used to enter numbers 0-9
IF B1!=$1C THEN GOTO JUMP2
B2=$41 'A
'GOTO JUMP44 'Test of system speed
JUMP2: 
IF B1!=$32 THEN GOTO JUMP3
B2=$42 'B
JUMP3:
IF B1!=$21 THEN GOTO JUMP4
B2=$43 'C
JUMP4:
IF B1!=$23 THEN GOTO JUMP5
B2=$44 'D
JUMP5:
IF B1!=$24 THEN GOTO JUMP6
B2=$45 'E
JUMP6:
IF B1!=$2B THEN GOTO JUMP7
B2=$46 'F
JUMP7:
IF B1!=$34 THEN GOTO JUMP8
B2=$47 'G
JUMP8:
IF B1!=$33 THEN GOTO JUMP9
B2=$48 'H
JUMP9:
IF B1!=$43 THEN GOTO JUMP10
B2=$49 'I
JUMP10:
IF B1!=$3B THEN GOTO JUMP11
B2=$4A 'J
JUMP11:
IF B1!=$42 THEN GOTO JUMP12
B2=$4B 'K
JUMP12:
IF B1!=$4B THEN GOTO JUMP13
B2=$4C 'L
JUMP13:
IF B1!=$3A THEN GOTO JUMP14
B2=$4D 'M
JUMP14:
IF B1!=$31 THEN GOTO JUMP15
B2=$4E 'N
JUMP15:
IF B1!=$44 THEN GOTO JUMP16
B2=$4F 'O
JUMP16:
IF B1!=$4D THEN GOTO JUMP17
B2=$50 'P
JUMP17:
IF B1!=$15 THEN GOTO JUMP18
B2=$51 'Q
JUMP18:
IF B1!=$2D THEN GOTO JUMP19
B2=$52 'R
JUMP19:
IF B1!=$1B THEN GOTO JUMP20
B2=$53 'S
JUMP20:
IF B1!=$2C THEN GOTO JUMP21
B2=$54 'T
JUMP21:
IF B1!=$3C THEN GOTO JUMP22
B2=$55 'U
JUMP22:
IF B1!=$2A THEN GOTO JUMP23
B2=$56 'V
JUMP23:
IF B1!=$1D THEN GOTO JUMP24
B2=$57 'W
JUMP24:
IF B1!=$22 THEN GOTO JUMP25
B2=$58 'X
JUMP25:
IF B1!=$35 THEN GOTO JUMP26
B2=$59 'Y
JUMP26:
IF B1!=$1A THEN GOTO JUMP27
B2=$5A 'Z
JUMP27:
IF B1!=$45 THEN GOTO JUMP28
B2=$29 ' )
JUMP28:
IF B1!=$16 THEN GOTO JUMP29
B2=$21 ' !
JUMP29:
IF B1!=$1E THEN GOTO JUMP30
B2=$40 ' @
JUMP30:
IF B1!=$26 THEN GOTO JUMP31
B2=$23 ' #
JUMP31:
IF B1!=$25 THEN GOTO JUMP32
B2=$24 ' $
JUMP32:
IF B1!=$2E THEN GOTO JUMP33
B2=$25 ' %
JUMP33:
IF B1!=$36 THEN GOTO JUMP34
B2=$5E ' ^
JUMP34:
IF B1!=$3D THEN GOTO JUMP35
B2=$26 ' &
JUMP35:
IF B1!=$3E THEN GOTO JUMP36
B2=$2A ' *
JUMP36:
IF B1!=$46 THEN GOTO JUMP37
B2=$28 ' (
JUMP37:
IF B1!=$55 THEN GOTO JUMP38
B2=$3D '=
JUMP38:
IF B1!=$79 THEN GOTO JUMP39
B2=$2B '+ KEYPAD
JUMP39:
IF B1!=$7B THEN GOTO JUMP40
B2=$2D '- KEYPAD
JUMP40:
IF B1!=$4A THEN GOTO JUMP41
B2=$2F '/ KEYPAD
JUMP41:
IF B1!=$7C THEN GOTO JUMP42
B2=$2A '* KEYPAD
JUMP42:
IF B1!=$29 THEN GOTO JUMP43
B2=$20 'Blank Space
JUMP43:
IF B1!=$5A THEN GOTO JUMP44
B2=$0D 'CR or ENTER
JUMP44:
IF B1!=$52 THEN GOTO JUMP45
B2=$22 ' "
JUMP45:
IF B1!=$41 THEN GOTO JUMP46
B2=$3C ' <
JUMP46:
IF B1!=$49 THEN GOTO JUMP47
B2=$3E ' >
JUMP47:
IF B1!=$70 THEN GOTO JUMP48
B2=$30 '0 KEYPAD
JUMP48:
IF B1!=$69 THEN GOTO JUMP49
B2=$31 '1 KEYPAD
JUMP49:
IF B1!=$72 THEN GOTO JUMP50
B2=$32 '2 KEYPAD
JUMP50:
IF B1!=$7A THEN GOTO JUMP51
B2=$33 '3 KEYPAD
JUMP51:
IF B1!=$6B THEN GOTO JUMP52
B2=$34 '4 KEYPAD
JUMP52:
IF B1!=$73 THEN GOTO JUMP53
B2=$35 '5 KEYPAD
JUMP53:
IF B1!=$74 THEN GOTO JUMP54
B2=$36 '6 KEYPAD
JUMP54:
IF B1!=$6C THEN GOTO JUMP55
B2=$37 '7 KEYPAD
JUMP55:
IF B1!=$75 THEN GOTO JUMP56
B2=$38 '8 KEYPAD
JUMP56:
IF B1!=$7D THEN GOTO JUMP57
B2=$39 '9 KEYPAD
JUMP57:
IF B1!=$76 THEN GOTO JUMP58
B2=$1B 'ESCAPE
JUMP58:
IF B1!=$71 THEN GOTO JUMP59
B2=$2E '.KEYPAD
JUMP59:
'Continue this list for all keys or translations desired...
'Send the new ASCII keypress character to the output port
LET PINSB=B2 'Note: I don't think a hex prefix is required
'Set the S-R Flip Flop to indicate a new keypress is available
LOW C.4 'This blocks KBD read during pulse
'PAUSE 10
PULSOUT C.0, 10
'PAUSE 10
HIGH C.4 'This allows KBD read during pulse
'Give chance for keypress to be acquired
'Wait for the keypress to be acquired by the bus
HIGHQ:
PAUSE 10
IF PINC.3=1 THEN GOTO HIGHQ
'We know a key can not be present. Block Read
LOW C.4
'Keypress has been acquired. Look for new Keypress after short pause
PAUSE 200
'Doubles at 10. No doubles at 100 (?) 
GOTO JUMP1
'Note that a new keypress can NOT be acquired when the buffer holds a key
